function [grad] = gradRSVMPlusl1_withoutMu(basicKernels,pos, alpha_sv, beta, compDist_vect_form, largeScale)

numFeatures  = size(basicKernels,3); 

denominator = 1 ./ (1 + beta' * compDist_vect_form); % size of denominator is 1xnumFeatures
denominator = denominator .* denominator; 

tmp = zeros(numFeatures, 1);

if largeScale == false
    for k = 1: numFeatures
        basicKernels(:,:,k) = basicKernels(:,:,k) * denominator(k);
        tmp(k) = 0.5 * alpha_sv' * basicKernels(pos,pos) * alpha_sv;
    end
else %% large scale
    D = basicKernels.numKernel; 
     for k = 1: D
        baseK = createKernel(basicKernels.X(:,k), basicKernels.kernelType); 
        baseK = baseK * denominator(k); 
        tmp(k,1) = 0.5 * alpha_sv' * baseK(pos,pos) * alpha_sv;
    end
end
    
grad =  - compDist_vect_form * tmp; 

% grad = zeros(length(beta), 1);
% K_cmp  =  zeros(numInstances, numInstances);
% for i = 1 : length(beta)
%      tmp = zeros(size(basicKernels));
%     for k = 1: numFeatures
%         tmp(:,:,k) = basicKernels(:,:,k) * (compDist_vect_form(i,k)/ (1 + beta' * compDist_vect_form)^2);
%     end
%     K_cmp  = sum(tmp,3); 
%     grad(i) =  0.5 * alpha_sv' * K_cmp(pos,pos) * alpha_sv; 
%     
% end;

%fprintf('finish computing gradient \n'); 