function rankedFeat = SVMRFE(X, Y, C, numEliminate, lambdareg)

% rankedFeat is ranked by descending order, i.e best features are at the
% beginning.
allFeatIndex = 1:size(X,2); 
rankedFeat = []; 

while length(rankedFeat) < size(X,2)
    feat_tmp = allFeatIndex(); 
    feat_tmp(rankedFeat) = []; 
    feat_tmp_index = allFeatIndex(setdiff(allFeatIndex, rankedFeat )); 
    
    K = X(:,feat_tmp) * X(:,feat_tmp)';  
   
    % Train SVM L1. Do Recursive Feature elimination
    [alpha, alpha_sv, obj_value, w_sqd, b, pos, train_err] = SVM(X(:,feat_tmp), Y, K, lambdareg, C,[]);
   
    % remove feature with smallest w_i*w_i
    w = alpha_sv' * X(pos,feat_tmp);
    [val ind] = sort(abs(w)); % sort  in ascending order.
    % ind = find(w == min(abs(w)));
    featureIndex = feat_tmp_index(ind(1:min(numEliminate, length(ind)))); 
    
    rankedFeat = [featureIndex rankedFeat]; 
    
end
