function [kernel] = combinedComponentKernels(basicKernels, beta, compDist_vect_form, largeScale)
% This is the kernel form of the J(beta) described in the paper (RSVM without mu)
% The basic kernels are kernels defined on 1 feature. 

% component distances is a vector (pdist(X))^2, size (n-2)(n-1)/2 where n
% is number of instances of X (row - instances, column- features)

% if largeScale, need to compute kernel on the fly, i.e there is no basickernels matrix



if largeScale == false
    [N N D] = size(basicKernels);
    kernel = zeros(N, N);
    for k = 1: D
        kernel = kernel + basicKernels(:,:,k)/ ( 1 + beta' * compDist_vect_form(:, k) );
    end
else %% large scale
     D = basicKernels.numKernel; 
     kernel = zeros(size(basicKernels.X,1), size(basicKernels.X,1));
     for k = 1: D
        baseK = createKernel(basicKernels.X(:,k), basicKernels.kernelType); 
        kernel = kernel + baseK / ( 1 + beta' * compDist_vect_form(:, k) );
    end
    
end

