function [R2 x0 ind] = componentRadiusSquared(X, kernel)

%% use quadprog function
%Standard quadprog in Matlab is too slow and the MaxIter is small
% It often give non-optimal result!!!
% So use monqp instead of quadprog
% numInstances = size(kernel,1);
% f= zeros(numInstances,1); % column vector
% for i= 1: numInstances
%     f(i,1) = -1 * kernel(i,i);
% end
% H = 2 * kernel;
% A = -1 *eye(numInstances); 
% b = zeros(numInstances,1); 
% beq = 1;
% Aeq = ones(1,numInstances);
% 
% [beta, R2] = quadprog(H, f,A,b,Aeq,beq);
% R2 = -1* R2;
% R2 : radius squared
% 
% %%
%----------------------------------------------------------------------
% %      monqpCinfty(H,b,c) solves the quadratic programming problem:
% % 
% %    min 0.5*x'Hx - d'x   subject to:  A'x = b  and  0 <= x 
% %     x    
% %----------------------------------------------------------------------
% % function [xnew, lambda, ind] = monqp0(H,c,A,b,l,verbose,X,ps)
% %
% % min 1/2  x' H x - c' x                
% %  x 
% % contrainte   A' x = b                     y'*x = 0 
% % 
% % et         0 <= x 
% 
numInstances = size(kernel,1);
H = 2 * kernel;
Aeq = ones(numInstances,1); 
beq = 1;

c = diag(kernel); 
 
%lambdareg = 1e-12; % only for the dataset which is badly scaled or nonconverge!!
lambdareg = 1e-12;

%  
% - Sonar, casekernel 3
% - musk case 3
% - wdbc, case 3
% - liver casekernel 1,3

[alpha, lambda, ind] = monqpCinfty(H,c,Aeq,beq, lambdareg);

alphaall = zeros(size(c));
alphaall(ind) = alpha;
obj = 0.5*alphaall'*H*alphaall -c'*alphaall;

%R2 : radius squared
 R2 = -obj;
 
 tmp = diag(alpha) * X(ind, :);  
 
 x0 = sum(tmp); 



% % test the correctness of the center and the radius
% 
%  for i = 1:length(ind)
%      (X(ind(i), :) - x0) * (X(ind(i), :) - x0)'
%  end
% %  
% % %  
%  for i = 1:numInstances
%      (X(i, :) - x0) * (X(i, :) - x0)'; 
%  end

%  % test if the value of R2 is correct
%  sqrt(R2)
%  for i = 1: size(X,1)
%      norm(x0-X(i,:))
%  end
 
 
%% R2 using cvx toolbox
% %% very fast as monqp
% try
% cvx_clear
% cvx_quiet(true)
% cvx_precision high
% 
% numInstances = size(kernel,1);
% H = kernel;
% % if(find(eig(H) < 0))
% %     R2 = 1 % matrix is not positive semidefinite 
% %     return;
% % end
% c = diag(kernel); % column vector
% C = ones(numInstances,1);
% 
% cvx_begin
%     variable varib(numInstances)
%     minimize (quad_form(varib,H) - c'*varib);
%     subject to
%         C'*varib == 1;
%         varib >= 0;
%    
% cvx_end
% R2 = - cvx_optval;
% catch exception
%    R2 = 1;
% 
% end
% 
%%%% BIG NOTE: DO NOT name the variable as 'alpha' or 'beta' , cvx will not
%%%% work for UNKNOWN reasons
