function [res] = statisticalTest(dataname, algorithm1, algorithm2, kernelType)

t1 = load([dataname '.' kernelType '.' algorithm1 '.allCVSplits.result.mat']);
t2 = load([dataname '.' kernelType '.' algorithm2 '.allCVSplits.result.mat']);

numSplits = t1.result.numSplit; 

err1 = zeros(numSplits,1); 
err2 = zeros(numSplits,1); 

pred1 =[];
pred2 =[];
Ytruelabel     =[];
count = 0;
for i = 1:numSplits
    try
	err1(i)  = t1.result.split{i}.averageErr;
	err2(i)  = t2.result.split{i}.averageErr;
	pred1 =[pred1; t1.result.split{i}.YPrediction];
	pred2 =[pred2; t2.result.split{i}.YPrediction];
	Ytruelabel=[Ytruelabel; t1.result.split{i}.Ytest];
    end
end


res.averageErr1 = mean(err1(err2>0)); 
res.averageErr2 = mean(err2(err2>0)); 

res.stdDev1 = std(err1(err2>0),1);
res.stdDev2 = std(err2(err2>0),1);


%% t-test
%http://www.mathworks.ch/help/toolbox/stats/ttest2.html

res.h = ttest2(err1(err2>0), err2(err2>0));

% null-hypothesis: two samples are equal mean and variance.
% h=1: reject the null hypothesis
% h= 0: cannot reject the null hypothesis
